<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="description" content="" />
    <meta name="author" content="" />
    <title>Coin of Farmer</title>

    <meta name="description" content="My Coin - Farmer" />
    <meta name="keywords" content="My Coin, BlockChain, Coin of Farmer" />

    <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.7.2/Chart.bundle.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.9/angular.min.js"></script>
    <script
      src="https://code.jquery.com/jquery-3.3.1.min.js"
      integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8="
      crossorigin="anonymous"
    ></script>
    <script
      defer
      src="https://use.fontawesome.com/releases/v5.3.1/js/all.js"
      integrity="sha384-kW+oWsYx3YpxvjtZjFXqazFpA7UP/MbiY4jvs+RWZo2+N94PFZ36T6TFkc9O3qoB"
      crossorigin="anonymous"
    ></script>
    <script src="https://unpkg.com/mathjs@5.2.2/dist/math.min.js"></script>

    <!-- Custom fonts for this template-->
    <link
      href="vendor/fontawesome-free/css/all.min.css"
      rel="stylesheet"
      type="text/css"
    />
    <link
      href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
      rel="stylesheet"
    />

    <!-- Custom styles for this template-->
    <link href="css/sb-admin-2.min.css" rel="stylesheet" />
    <link href="css/my-coin.css" rel="stylesheet" />
  </head>

  <body
    data-spy="scroll"
    data-target="#pb-navbar"
    data-offset="200"
    ng-app="BlockExplorer"
  >
    <!-- Page Wrapper -->
    <div id="wrapper">
      <!-- Sidebar -->
      <ul
        class="navbar-nav bg-gradient-primary sidebar sidebar-dark accordion"
        id="accordionSidebar"
      >
        <!-- Sidebar - Brand -->
        <a
          class="sidebar-brand d-flex align-items-center justify-content-center"
          href="index.html"
        >
          <div class="sidebar-brand-icon rotate-n-15">
            <i class="fas fa-laugh-wink"></i>
          </div>
          <div class="sidebar-brand-text mx-3">My Coin<sup>2</sup></div>
        </a>

        <!-- Divider -->
        <hr class="sidebar-divider my-0" />

        <!-- Nav Item - Dashboard -->
        <li class="nav-item active">
          <a class="nav-link" href="index.html">
            <i class="fas fa-fw fa-tachometer-alt"></i>
            <span>Dashboard</span></a
          >
        </li>

        <!-- Divider -->
        <hr class="sidebar-divider" />

        <!-- Nav Item - Pages Collapse Menu -->
        <li class="nav-item">
          <a
            class="nav-link collapsed"
            href="#"
            data-toggle="collapse"
            data-target="#collapseTwo"
            aria-expanded="true"
            aria-controls="collapseTwo"
          >
            <i class="fas fa-coins"></i>
            <span>Coin</span>
          </a>
          <div
            id="collapseTwo"
            class="collapse"
            aria-labelledby="headingTwo"
            data-parent="#accordionSidebar"
          >
            <div class="bg-white py-2 collapse-inner rounded">
              <a class="collapse-item" href="send-coin.html">Send Coin</a>
              <a class="collapse-item" href="history.html">History</a>
            </div>
          </div>
        </li>

        <!-- Divider -->
        <hr class="sidebar-divider d-none d-md-block" />

        <!-- Sidebar Toggler (Sidebar) -->
        <div class="text-center d-none d-md-inline">
          <button class="rounded-circle border-0" id="sidebarToggle"></button>
        </div>
      </ul>
      <!-- End of Sidebar -->

      <!-- Content Wrapper -->
      <div id="content-wrapper" class="d-flex flex-column">
        <!-- Main Content -->
        <div id="content">
          <!-- Topbar -->
          <nav
            class="
              navbar navbar-expand navbar-light
              bg-white
              topbar
              mb-4
              static-top
              shadow
            "
          >
            <!-- Sidebar Toggle (Topbar) -->
            <button
              id="sidebarToggleTop"
              class="btn btn-link d-md-none rounded-circle mr-3"
            >
              <i class="fa fa-bars"></i>
            </button>

            <!-- Topbar Search -->
            <form
              class="
                d-none d-sm-inline-block
                form-inline
                mr-auto
                ml-md-3
                my-2 my-md-0
                mw-100
                navbar-search
              "
            >
              <div class="input-group">
                <input
                  type="text"
                  class="form-control bg-light border-0 small"
                  placeholder="Search for..."
                  aria-label="Search"
                  aria-describedby="basic-addon2"
                />
                <div class="input-group-append">
                  <button class="btn btn-primary" type="button">
                    <i class="fas fa-search fa-sm"></i>
                  </button>
                </div>
              </div>
            </form>

            <!-- Topbar Navbar -->
            <ul class="navbar-nav ml-auto">
              <!-- Nav Item - Search Dropdown (Visible Only XS) -->
              <li class="nav-item dropdown no-arrow d-sm-none">
                <a
                  class="nav-link dropdown-toggle"
                  href="#"
                  id="searchDropdown"
                  role="button"
                  data-toggle="dropdown"
                  aria-haspopup="true"
                  aria-expanded="false"
                >
                  <i class="fas fa-search fa-fw"></i>
                </a>
                <!-- Dropdown - Messages -->
                <div
                  class="
                    dropdown-menu dropdown-menu-right
                    p-3
                    shadow
                    animated--grow-in
                  "
                  aria-labelledby="searchDropdown"
                >
                  <form class="form-inline mr-auto w-100 navbar-search">
                    <div class="input-group">
                      <input
                        type="text"
                        class="form-control bg-light border-0 small"
                        placeholder="Search for..."
                        aria-label="Search"
                        aria-describedby="basic-addon2"
                      />
                      <div class="input-group-append">
                        <button class="btn btn-primary" type="button">
                          <i class="fas fa-search fa-sm"></i>
                        </button>
                      </div>
                    </div>
                  </form>
                </div>
              </li>

              <!-- Nav Item - Alerts -->
              <li class="nav-item dropdown no-arrow mx-1">
                <a
                  class="nav-link dropdown-toggle"
                  href="#"
                  id="alertsDropdown"
                  role="button"
                  data-toggle="dropdown"
                  aria-haspopup="true"
                  aria-expanded="false"
                >
                  <i class="fas fa-bell fa-fw"></i>
                  <!-- Counter - Alerts -->
                  <span class="badge badge-danger badge-counter">3+</span>
                </a>
              </li>

              <div class="topbar-divider d-none d-sm-block"></div>

              <!-- Nav Item - User Information -->
              <li class="nav-item dropdown no-arrow">
                <a
                  class="nav-link dropdown-toggle"
                  href="#"
                  id="userDropdown"
                  role="button"
                  data-toggle="dropdown"
                  aria-haspopup="true"
                  aria-expanded="false"
                >
                  <span
                    class="mr-2 d-none d-lg-inline text-gray-600 small"
                    ng-controller="walletController"
                    >{{addressData}}</span
                  >
                  <img
                    class="img-profile rounded-circle"
                    src="img/undraw_profile.svg"
                  />
                </a>
                <!-- Dropdown - User Information -->
                <div
                  class="
                    dropdown-menu dropdown-menu-right
                    shadow
                    animated--grow-in
                  "
                  aria-labelledby="userDropdown"
                >
                  <a class="dropdown-item" href="#">
                    <i class="fas fa-user fa-sm fa-fw mr-2 text-gray-400"></i>
                    Profile
                  </a>
                  <a class="dropdown-item" href="#">
                    <i class="fas fa-cogs fa-sm fa-fw mr-2 text-gray-400"></i>
                    Settings
                  </a>
                  <a class="dropdown-item" href="#">
                    <i class="fas fa-list fa-sm fa-fw mr-2 text-gray-400"></i>
                    Activity Log
                  </a>
                  <div class="dropdown-divider"></div>
                  <a
                    class="dropdown-item"
                    href="#"
                    data-toggle="modal"
                    data-target="#logoutModal"
                  >
                    <i
                      class="fas fa-sign-out-alt fa-sm fa-fw mr-2 text-gray-400"
                    ></i>
                    Logout
                  </a>
                </div>
              </li>
            </ul>
          </nav>
          <!-- End of Topbar -->

          <!-- Begin Page Content -->
          <div class="container-fluid">
            <!-- Page Heading -->
            <div
              class="d-sm-flex align-items-center justify-content-between mb-4"
            >
              <h1 class="h3 mb-0 text-gray-800">History</h1>
            </div>

            <!-- Content Row -->
            <div class="row" ng-controller="walletController">
              <!-- Earnings (Monthly) Card Example -->
              <div class="col mb-4">
                <div class="card border-left-primary shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="
                            text-xs
                            font-weight-bold
                            text-primary text-uppercase
                            mb-1
                          "
                        >
                          Address
                        </div>
                        <div
                          class="
                            h5
                            mb-0
                            font-weight-bold
                            text-gray-800
                            break-word
                          "
                        >
                          {{addressData}}
                        </div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-calendar fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <!-- Earnings (Monthly) Card Example -->
              <div class="col mb-4">
                <div class="card border-left-success shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="
                            text-xs
                            font-weight-bold
                            text-success text-uppercase
                            mb-1
                          "
                        >
                          Balance
                        </div>
                        <div class="h5 mb-0 font-weight-bold text-gray-800">
                          $ {{amount}}
                        </div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-dollar-sign fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <!-- Earnings (Monthly) Card Example -->
              <div class="col mb-4">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="
                            text-xs
                            font-weight-bold
                            text-info text-uppercase
                            mb-1
                          "
                        >
                          Network
                        </div>
                        <div class="row no-gutters align-items-center">
                          <div class="col-auto">
                            <div
                              class="
                                h5
                                mb-0
                                mr-3
                                font-weight-bold
                                text-gray-800
                              "
                            >
                              Last block# : {{lastBlock}}
                            </div>
                          </div>
                        </div>
                      </div>
                      <div class="col-auto">
                        <i
                          class="fas fa-clipboard-list fa-2x text-gray-300"
                        ></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <div class="card shadow mb-4" ng-controller="transactionHistoryController">
                <div class="card-header py-3">
                    <h6 class="m-0 font-weight-bold text-primary">Latest Transactions</h6>
                </div>
                <div class="card-body">
                    <div class="table-responsive">
                        <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                            <thead>
                                <tr>
                                    <th>transactionID</th>
                                    <th>amount</th>
                                    <th>date</th>
                                    <th>sender</th>
                                    <th>recipient</th>
                                </tr>
                            </thead>
                            <tfoot>
                                <tr>
                                    <th>transactionID</th>
                                    <th>amount</th>
                                    <th>date</th>
                                    <th>sender</th>
                                    <th>recipient</th>
                                </tr>
                            </tfoot>
                            <tbody>                                 
                                <tr class="col-2 text-truncate" ng-repeat="transaction in transactions track by $index">
                                    <td class="text-truncate">
                                        <div style="width: 150px;" class="text-truncate">
                                            {{ transaction.transactionId }}
                                        </div>
                                    </td>
                                    <td class="text-truncate">
                                        <div style="width: 50px;" class="text-truncate">
                                            {{ transaction.amount }}
                                        </div>
                                    </td>
                                    <td class="text-truncate">
                                        <div style="max-width: 300px;" class="text-truncate">
                                            {{ transaction.date }}
                                        </div>
                                    </td>
                                    <td class="text-truncate">
                                        <div style="width: 300px;" class="text-truncate">
                                            {{ transaction.sender }}
                                        </div>
                                    </td>
                                    <td class="text-truncate"> 
                                        <div style="width: 300px;" class="text-truncate">
                                            {{ transaction.recipient }}
                                        </div>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
                <div ng-controller="miningController">
                  <div class="row">
                    <div
                      class="col-2"
                      data-toggle="modal"
                      data-target="#miningModal"
                      title="By clicking this button you can enable all transactions awaiting approval"
                    >
                      <button
                        id="mineButton"
                        class="btn btn-primary btn-icon-split botton1"
                        style="vertical-align: middle"
                      >
                        <span>Perform mining</span>
                      </button>
                    </div>
                  </div>

                      <!-- Mining Modal-->
                        <div
                        class="modal fade"
                        id="miningModal"
                        tabindex="-1"
                        role="dialog"
                        aria-labelledby="exampleModalLabel"
                        aria-hidden="true"
                    >
                        <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">
                                Mining Confirmation
                            </h5>
                            <button
                                class="close"
                                type="button"
                                data-dismiss="modal"
                                aria-label="Close"
                            >
                                <span aria-hidden="true">×</span>
                            </button>
                            </div>
                            <div class="modal-body">Are you sure you want to mine?</div>
                            <div class="modal-footer">
                            <button
                                class="btn btn-secondary"
                                type="button"
                                data-dismiss="modal"
                            >
                                No
                            </button>
                            <button class="btn btn-primary" type="button" ng-click="mine()">Yes</button>
                            </div>
                        </div>
                        </div>
                    </div>
                </div>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </div>
        <!-- End of Main Content -->

        <!-- Footer -->
        <footer class="sticky-footer bg-white mrTop-40">
          <div class="container my-auto">
            <div class="copyright text-center my-auto">
              <span>Copyright &copy; Your Website 2021</span>
            </div>
          </div>
        </footer>
        <!-- End of Footer -->
      </div>
      <!-- End of Content Wrapper -->
    </div>
    <!-- End of Page Wrapper -->

    <!-- Scroll to Top Button-->
    <a class="scroll-to-top rounded" href="#page-top">
      <i class="fas fa-angle-up"></i>
    </a>

    <!-- Logout Modal-->
    <div class="modal fade" id="logoutModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
        aria-hidden="true" ng-controller="logoutController">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Ready to Leave?</h5>
                    <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                </div>
                <div class="modal-body">Select "Logout" below if you are ready to end your current session.</div>
                <div class="modal-footer">
                    <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
                    <button type="button" ng-click="logout()" class="btn btn-primary" >Logout</button>
                </div>
            </div>
        </div>
    </div>

    <!-- Bootstrap core JavaScript-->
    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>

    <!-- Core plugin JavaScript-->
    <script src="vendor/jquery-easing/jquery.easing.min.js"></script>

    <!-- Custom scripts for all pages-->
    <script src="js/sb-admin-2.min.js"></script>

    <script>
      window.app = angular.module("BlockExplorer", []);

      const publicKey = localStorage.getItem("publicKey");

      if (!publicKey) {
        window.location.href = "./login.html";
      }

      ////////////////////////////////////////////////////////////////////
        app.controller('logoutController', function ($scope, $http) {
            $scope.logout = function () {
               localStorage.removeItem('publicKey');
               localStorage.removeItem('privateKey');

               window.location.href = "./login.html";
            };
        });

      ////////////////////////////////////////////////////////////////////
      app.controller("walletController", function ($scope, $http) {
        $scope.addressData = localStorage.getItem("publicKey");
        $scope.amount = 0;
        $scope.lastBlock = "None";

        $scope.init = (function () {
          $http.get(`/address-info/${$scope.addressData}`).then((response) => {
            $scope.amount = response.data.amount;
            $scope.lastBlock = response.data.lastBlock;
          });
        })();
      });

        ///////////////////////////////////////////////////////////////////
        app.controller('transactionHistoryController', function ($scope, $http) {
            $scope.addressData = localStorage.getItem('publicKey');

            $scope.init = function () {
                $http.get(`/lasted-transactions/${$scope.addressData}`)
                    .then(response => {
                        $scope.transactions = response.data.transactions;
                    });
            }();
        });

      ///////////////////////////////////////////////////////////////////
      app.controller("miningController", function ($scope, $http, $timeout) {
        $scope.mineSuccesss = null;

        $scope.mine = function () {
          const key1 = localStorage.getItem('privateKey');
          const key2 = localStorage.getItem('publicKey');

          $http({
            url: "/hashKeys",
            method: "POST",
            data: {
              key1: key1,
              key2: key2,
            },
          }).then(
            function (response) {
              if (response.data.note === false) {
                alert("Incompatible keys");
              } else {
                $http.get(`/mine/${key2}`).then((response) => {
                  //mining sccess
                  $("#lastTransactionsTable td").remove();
                  $.get("/emitMiningSuccess", (data, status) => {
                    //http request via JQuery
                    console.log(data);
                  });
                  $scope.mineSuccesss = true;
                  $timeout(function () {
                    //remove 'mining success' message
                    $scope.mineSuccesss = false;
                  }, 4000);
                  $timeout(function () {
                    location.reload();
                  }, 5000);
                });
              }
            },
            function (response) {}
          );
        };
      });
    </script>

    <script src="/socket.io/socket.io.js"></script>
    <script src="sockets.js"></script>
  </body>
</html>
